﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Text.Json;

namespace CarShop.ConsoleClient
{
    // Alternative: add Newtonsoft.JSON via NuGet (System.Text.Json is dotnet 5)
    // Set startup projects: multiple
    // TODO: NSwag / SwashBuckle
    public class Car
    {
        public int Id { get; set; }
        public string BrandName { get; set; }
        public string Name { get; set; }
        public int Price { get; set; }
        public override string ToString()
        {
            return $"ID={Id}\tBrand={BrandName}\tModel={Name}\tPrice={Price}";
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            string url = "http://localhost:5922/CarsApi/";
            Console.WriteLine("WAITING...");
            Console.ReadLine();

            // No error handling at all...
            // using (WebClient client = new WebClient())
            JsonSerializerOptions jsonOptions = new JsonSerializerOptions(JsonSerializerDefaults.Web);

            using (HttpClient client = new HttpClient())
            {
                string json = client.GetStringAsync(url + "all").Result;
                // var list = JsonConvert.DeserializeObject<List<Car>>(json);
                var list = JsonSerializer.Deserialize<List<Car>>(json, jsonOptions);
                foreach (var item in list) Console.WriteLine(item);
                Console.ReadLine();

                // NameValueCollection postData; // WebClient
                // byte[] responseBytes; // WebClient
                Dictionary<string, string> postData;
                string response;

                postData = new Dictionary<string, string>();
                postData.Add(nameof(Car.BrandName), "BMW");
                postData.Add(nameof(Car.Name), "M5");
                postData.Add(nameof(Car.Price), "120000");
                // responseBytes = client.UploadValues(url + "add", "POST", postData);
                // response = Encoding.UTF8.GetString(responseBytes);

                response = client.PostAsync(url + "add", new FormUrlEncodedContent(postData)).Result.Content.ReadAsStringAsync().Result;
                json = client.GetStringAsync(url + "all").Result;
                Console.WriteLine("ADD: " + response);
                Console.WriteLine("ALL: " + json);
                Console.ReadLine();

                // int carId = JsonConvert.DeserializeObject<List<Car>>(json).Single(x => x.Name == "M5").Id;
                int carId = JsonSerializer.Deserialize<List<Car>>(json, jsonOptions).Single(x => x.Name == "M5").Id;
                postData = new Dictionary<string, string>();
                postData.Add(nameof(Car.Id), carId.ToString());
                postData.Add(nameof(Car.BrandName), "BMW");
                postData.Add(nameof(Car.Name), "M5 PLUS");
                postData.Add(nameof(Car.Price), "150000");

                response = client.PostAsync(url + "mod",
                    new FormUrlEncodedContent(postData)).Result.Content.ReadAsStringAsync().Result;
                Console.WriteLine("MOD: " + response);
                Console.WriteLine("ALL: " + client.GetStringAsync(url + "all").Result);
                Console.ReadLine();

                Console.WriteLine("DEL: " + client.GetStringAsync(url + "del/" + carId).Result);
                Console.WriteLine("ALL: " + client.GetStringAsync(url + "all").Result);
                Console.ReadLine();
                // TODO: Client side filter vs serverside filter, no IQueryable
                // TODO: Client side paging OR server side paging?????
            }
        }
    }

}
