﻿using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using GalaSoft.MvvmLight.Messaging;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Documents;
using System.Windows.Input;

namespace CarShop.Wpf
{
    class MainVM : ViewModelBase
    {
		private MainLogic logic;
		private ObservableCollection<CarVM> allCars;
		private CarVM selectedCar;

		public CarVM SelectedCar
		{
			get { return selectedCar; }
			set { Set(ref selectedCar, value); }
		}
		public ObservableCollection<CarVM> AllCars
		{
			get { return allCars; }
			set { Set(ref allCars, value); }
		}

		public Func<CarVM, bool> EditorFunc { get; set; }

		public ICommand AddCmd { get; private set; }
		public ICommand DelCmd { get; private set; }
		public ICommand ModCmd { get; private set; }
		public ICommand LoadCmd { get; private set; }


		public MainVM()
		{
			logic = new MainLogic(); // TODO: IoC + Dependency Injection !!!

			LoadCmd = new RelayCommand(() =>
					AllCars = new ObservableCollection<CarVM>(logic.ApiGetCars()));
			DelCmd = new RelayCommand(() => logic.ApiDelCar(selectedCar) );
			AddCmd = new RelayCommand(() => logic.EditCar(null, EditorFunc));
			ModCmd = new RelayCommand(() => logic.EditCar(selectedCar, EditorFunc));
		}
		// https://stackoverflow.com/questions/15687415/how-to-synchronize-model-and-view-model-bidirectional-in-mvvm
		// https://stackoverflow.com/questions/10437241/mvvm-binding-to-model-while-keeping-model-in-sync-with-a-server-version
		// https://nathan.alner.net/2010/02/09/mvvm-to-wrap-or-not-to-wrap-how-much-should-the-viewmodel-wrap-the-model-part-1/
	}
}
